import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Key here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Key  extends Actor
{
    static GreenfootImage Wkey = new GreenfootImage("White Key.gif");
    static GreenfootImage Wkeydown = new GreenfootImage("White Key Pressed.gif");
    static GreenfootImage Bkey = new GreenfootImage("Black Key.gif");
    static GreenfootImage Bkeydown = new GreenfootImage("Black Key Pressed.gif");
    WhiteDot wd;// = null;
    
    String keyArray[] = {"q","w","e","r","t","y","u","i","o","p","[","]","\\","x","x","2","3","4","5","6","7","8","9","0","-"};
    int keyNumArray[] = {36,38,40,41,43,45,47,48,50,52,53,55,57,59,60,37,39,42,44,46,49,51,54,56,58};
    
    PianoWorld p;
    boolean keyPressed = false;
    boolean keyboardPressed = false;
    boolean locationSet = false; // I guess you can't set the location in a constructor, so just do it in act()
    boolean blackkey = false;
    boolean dotonkey = false; // don't push when this is true
    boolean clicked = false; /*boolean clicked1 = false;*/
    int keynumber = 0;
    int delay = 0; // delay an action by one cycle
    
    boolean tobereleased = false;
    
    static MouseInfo m;
    static int mouseX = 0; static int mouseY = 0;
    
    public Key(int num) {
        if (num>=15) {
            setImage(Bkey); blackkey = true;
        } else {
            setImage(Wkey);
        }
        // keynumber tells which kind of key it is...0-15 = white keys, 16-25 = black keys
        keynumber = num;
    }
    
    /**
     * Act - do whatever the Key wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Put the keys in the right spot
        if (!locationSet) {
            locationSet = true;
            p = (PianoWorld) getWorld();
            placeKey(); // put the key somewhere...
        }
        //trackMouse(); // track the mouse..
        handleInput(); // if there is a mouse, or a key pressed, handle it!
        
        // was the sustain pedal pressed?  if released, then release the key
        if (!Greenfoot.isKeyDown("space")) {
            if (tobereleased) {
                releaseKey();
            }
        }
    }    
    
    public void trackMouse() {
           if (Greenfoot.mouseMoved(null)) {
               m = Greenfoot.getMouseInfo();
               mouseX = m.getX(); mouseY = m.getY();
           }
    }
    
    public void handleInput() {
       if (!Greenfoot.mouseDragged(null)) {
           if (Greenfoot.mousePressed(this) && !keyboardPressed) {
               pushKey(); // push the key
               clicked = true; //clicked1 = true;
           }
       } else {
           if (!dotOnKey() && !keyboardPressed) {
              if (!clicked) {
                   releaseKey();
              }
           }
       }
       // ok I have a white dot that tests for collisions and plays notes and follows the mouse around.  But it doesn't follow
       // the mouse before the key acts.  So to prevent the note from playing twice (once when clicked, and once when he mouse is
       // moved) I have this complicated logic.  There might be a better way to do this... but this works so ... whatever

       if (clicked) {
            if (Greenfoot.mouseDragged(null)) {
                    clicked = false;
            }
        }
        
        //if (!Greenfoot.mousePressed(this) && !dotOnKey()) {
         //   releaseKey();
        //}
        
        if (Greenfoot.mouseClicked(null) && !keyboardPressed /*&& clicked1*/) {
            releaseKey(); // release the key, if it is pressed
            //clicked1 = false;
        }
        
        if (Greenfoot.isKeyDown(keyArray[keynumber])) {
            if (!keyboardPressed) {
                pushKey();
            }
            keyboardPressed = true;
        } else {
            if (keyboardPressed) {
                releaseKey();
                keyboardPressed = false;
            }
        }
        
        //if (!mouseOnKey()&&!keyboardPressed) {
            // don't push if the mouse is not on the key!
             //releaseKey(); 
            //setImage(Wkeydown);
        //} else {
           // dontpush = false;
            //setImage(Wkey);
       // }
    }
    
    public boolean dotOnKey() {
        trackMouse();
        wd = null;
        wd = (WhiteDot) getOneIntersectingObject(WhiteDot.class);
        if (wd != null) {
            if (!blackkey) {
                if (wd.onBlack()) {
                    dotonkey = false; return false;
                }
            }
            dotonkey = true;
            return true;
        }
       // if ((Math.abs(getX()-p.rwdx())<getImage().getWidth()/2)&&(Math.abs(getY()-p.rwdy())<getImage().getHeight()/2)) {
       //      dotonkey = true;
       //     return true;
       // }
        dotonkey = false;
        return false;
    }
    
    public void makeBox() {
        getWorld().addObject(new Rs(keynumber), Greenfoot.getRandomNumber(500),Greenfoot.getRandomNumber(300));
    }
    
    public void pushKey() {
        keyPressed = true;
        //getWorld().addObject(new Rs(keynumber), Greenfoot.getRandomNumber(500),Greenfoot.getRandomNumber(300));

            p.noteDown(keyNumArray[keynumber]); // tell piano world the key is down so it will play a sound
            if (keynumber < 15) {
                setImage(Wkeydown);
            } else {
                setImage(Bkeydown);
            }

    }
    
    public void releaseKey() {
        if (Greenfoot.isKeyDown("space")) {
            // don't release the key, but set "To be released" to true
            tobereleased = true;
        }
        else {
            if (keyPressed || keyboardPressed) {
                if (keynumber < 15) {
                    setImage(Wkey);
                } else {
                    setImage(Bkey);
                }
                p.noteUp(keyNumArray[keynumber]); // tell pianoworld the key is up so it will stop the sound
                //getWorld().addObject(new Rs(keynumber), Greenfoot.getRandomNumber(500),Greenfoot.getRandomNumber(300));
                keyPressed = false;
            }
            tobereleased = false;
        }
    }
    
    public boolean isBlack() {
        return blackkey;
    }
    
    public boolean isPushed() {
        return keyPressed;
    }
    // this method is nessesary because 
    public void dontRepeatIfDraggedOn() {
    }
    
    public int getKeyNum() {
        return keynumber;
    }
    
    public void placeKey() {
        //int a, b;
        // lets put the first key at 45,130
        int a = 45; int b = 302;
        int w = Wkey.getWidth()-2;
        if (keynumber > 25) {keynumber = 25;}
        if (keynumber < 0) {keynumber = 0;}
        // white keys are easy!
        if (keynumber < 15) {
            a += keynumber*w;
        } else { // black keys are trickier!
            b = 278;
            a = (int) (w/2) + ((keynumber-14)*w)+6;
            // gotta adjust for the gaps in the black keys now!!
            if (keynumber > 16) a += w;
            if (keynumber > 19) a += w;
            if (keynumber > 21) a += w;
        }
        setLocation(a,b);
    }

}