import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import javax.sound.midi.*;

/**
 * Write a description of class PianoWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PianoWorld  extends World 
{
    // variables for midi
    int notenum = 0;
    int transpose = 0;
    int intensity = 50;
    
    int ins = 2;
    // stuff for controlling the instrument, etc.
    Instrument instrument = new Instrument();
    Transpose transposer = new Transpose();
    Intensity intensityselector = new Intensity();
    
    // essential midi stuff
    Synthesizer synthesizer;
    MidiChannel channel;
    
    // piano keys.  
    Key keys[] = new Key[25];
    WhiteDot wd = new WhiteDot();
    
    /**
     * Constructor for objects of class PianoWorld.
     * 
     */
    public PianoWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(650, 400, 1); 
        setUpKeys(); // sets up the keys
        setUpMidi(); // ain't so hard....
        addObject(instrument,145,171);
        addObject(transposer,325,171);
        addObject(intensityselector,505,171);
        addObject(new Message(),322,386);
        addObject(wd,0,0);
    }
    
    public void setUpMidi() {
        try {
            synthesizer = MidiSystem.getSynthesizer();
            synthesizer.open();
            channel = synthesizer.getChannels()[0]; // not sure exactly how getChannels works... but oh well
        } catch (Exception ex) {
        }
    }
    
    public void setIntensity(int n) {
        intensity = n;
    }
    
    public void setTranspose(int n) {
        transpose = n;
    }
    
    public void setInstrument(int n) {
        channel.programChange(n);
        ins = n;
    }
    
    public void setUpKeys() {
        // set up the white keys. 0-15 = white keys
        for (int i = 0; i < 25; i++) {
            keys[i] = new Key(i);
            addObject(keys[i],0,0);
        }
    }
    // maybe a future feture....
    public void playChord()
    {
        keys[0].pushKey();
        keys[2].pushKey();
        keys[4].pushKey();
    }
    
    public void noteDown(int note) {
        channel.noteOn(note+transpose,intensity);
    }
    
    public void noteUp(int note) {
        channel.noteOff(note+transpose,intensity);
    }
    
    public int rwdx() {
        return wd.getX();
    }
    
    public int rwdy() {
        return wd.getY();
    }
    
    public void stopped()
    {
        try {
            channel.allNotesOff();
        }
        catch(Exception ex) {}
    }
}
